//Multiple Steppers - Rocket Surgeon
//Carl P-Conquilla 2018 for FabAcademy


#include <AccelStepper.h>
#define SPEED 937
AccelStepper stepper1(AccelStepper::FULL4WIRE, 6, 7, 8, 9);
AccelStepper stepper2(AccelStepper::FULL4WIRE, 10, 11, 12, 13);
AccelStepper stepper3(AccelStepper::FULL4WIRE, A0, 3, 4, 5);

int thresHi = 600;
int thresLo = 400;
int joyx = 512;
int joyy = 512;

void setup()
{  
    stepper1.setMaxSpeed(SPEED);
    stepper2.setMaxSpeed(SPEED);
    stepper3.setMaxSpeed(SPEED);
}

void loop()
{
    joyx = analogRead(A7);
    joyy = analogRead(A1);

    // Change direction at the limits
//    if (stepper1.currentPosition() > 2000)
//        stepper1.setSpeed(-SPEED);
//    if (stepper1.currentPosition() < 20)
//        stepper1.setSpeed(SPEED);
        
    // Cases for joystick higher or lower than the resting point
    if (joyx<thresLo){
        stepper2.setSpeed(-SPEED);
    }
    if (joyx>thresHi){
        stepper2.setSpeed(SPEED);
    }
    if (joyy<thresLo){
        stepper3.setSpeed(-SPEED);
    }
    if (joyy>thresHi){
        stepper3.setSpeed(SPEED);
    }
    
    // If the joystick returns to deadspot release the steppers
    // Also only do this if they're not already stopped
    if (joyx<thresHi && joyx>thresLo && (stepper2.speed() != 0)){
      releaseStepper(2);
      stepper2.setSpeed(0);
     }
    if (joyy<thresHi && joyy>thresLo && (stepper3.speed() != 0)){
      releaseStepper(3);
      stepper3.setSpeed(0);
     }
     
    // Run whatever speed the motors have been set to
    stepper1.runSpeed();
    stepper2.runSpeed();
    stepper3.runSpeed();

}

void releaseStepper(int stepperNumber){
  //Releases the pins for steppers so they don't stutter
  //  or draw current while stationary
    switch (stepperNumber) {
      case 1:
          digitalWrite(6, LOW);
          digitalWrite(7, LOW);
          digitalWrite(8, LOW);
          digitalWrite(9, LOW);
      case 2:
          digitalWrite(10, LOW);
          digitalWrite(11, LOW);
          digitalWrite(12, LOW);
          digitalWrite(13, LOW); 
      case 3:
          digitalWrite(A0, LOW);
          digitalWrite(3, LOW);
          digitalWrite(4, LOW);
          digitalWrite(5, LOW);
    }
}

